////////////////////////////////////////////////////////////
//
//            EMBEDDED SYSTEM PROGRAMMING
//
//										COMPUTER SCIENCE
//
//										2201113 박우람
//										2501220 박대선
//										2501230 우연화
//										2501324 민충희
//
////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <string.h>
#include <termios.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <asm/ioctls.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include "race.h"

// 맵 배열
int arrRacingMap[5][35][5] = {
	{		
		{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},
		{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},
		{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},
		{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},
		{0,0,0,0,0},{0,0,1,0,0},{0,0,1,0,0},{0,1,1,1,0},{0,1,1,1,0},
		{0,0,1,0,0},{0,0,1,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},
		{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{1,0,0,0,1}
	},	//map1 끝
	{	
		{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},
		{1,0,0,0,1},{1,0,0,0,0},{1,1,0,0,0},{1,1,0,0,0},{1,1,0,0,0},
		{1,1,0,0,0},{1,1,0,0,0},{1,1,0,0,0},{1,1,1,0,0},{1,1,1,0,0},
		{1,1,1,0,0},{1,1,0,0,0},{1,1,0,0,0},{1,1,0,0,0},{1,1,0,0,0},
		{1,1,0,0,0},{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,1},{1,0,0,0,1},
		{1,0,0,0,1},{1,0,0,0,1},{1,0,0,1,1},{1,0,0,1,1},{1,0,0,1,1},
		{1,0,0,1,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1} 
	},	//map2 끝
	{
		{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},
		{1,0,0,0,1},{1,0,0,0,1},{1,1,0,0,0},{1,1,0,0,0},{1,1,0,0,0}, 
		{1,1,0,0,0},{1,1,0,0,0},{1,1,0,0,0},{1,1,0,0,0},{1,0,0,0,0}, 
		{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1}, 
		{1,0,0,0,1},{0,0,0,1,1},{0,0,0,1,1},{0,0,0,0,1},{0,0,0,0,1}, 
		{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,0},{1,1,0,0,0},{1,1,0,0,0}, 
		{1,0,0,0,0},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1} 
	},	//map3 끝
	{
		{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{0,0,0,0,1}, 
		{0,0,0,0,1},{0,0,0,0,1},{0,0,0,1,1},{0,0,0,1,1},{0,0,0,1,1}, 
		{0,0,0,1,1},{0,0,0,0,1},{0,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1}, 
		{1,0,0,0,1},{1,1,0,0,1},{1,1,0,0,0},{1,1,0,0,0},{1,1,0,0,0}, 
		{1,1,0,0,0},{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,1},{1,0,0,0,1}, 
		{1,0,0,0,1},{1,0,0,0,1},{1,0,0,1,1},{1,0,0,1,1},{1,0,0,1,1}, 
		{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1},{1,0,0,0,1} 
	},	//map4 끝
	{
		{1,0,0,0,1},{0,0,0,0,1},{0,0,0,0,1},{0,0,0,0,1},{0,0,0,0,1}, 
		{0,0,0,0,1},{0,0,0,0,1},{0,0,0,1,1},{0,0,0,1,1},{0,0,1,1,1}, 
		{0,0,1,1,1},{0,0,1,1,1},{0,0,0,1,1},{0,0,0,1,1},{0,0,0,0,1}, 
		{0,0,0,0,1},{0,0,0,0,0},{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,0}, 
		{1,0,0,0,0},{1,1,0,0,0},{1,1,0,0,0},{1,0,0,0,0},{1,0,0,0,1}, 
		{0,0,0,0,1},{0,0,0,1,1},{0,0,0,1,1},{0,0,0,0,1},{0,0,0,0,1}, 
		{1,0,0,0,1},{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,0},{1,0,0,0,1}
	}	//map5 끝
};

// 메인함수, 디바이스들을 초기화하고 키 입력을 처리한다.
int main(void)
{
	pthread_t threadMap;
	pthread_t threadSpeed;
	pthread_t threadRefresh;
	pthread_t threadCredit;
	char cLetter;

	// initialize KEY
	if((fdKey = open(DEVICE_KEY, O_RDONLY)) < 0)
	{
		perror("open fail /dev/key");
		exit(-1);
	}

	// initialize LED
	if((fdLed = open(DEVICE_LED, O_RDWR)) < 0)
	{
		perror("open fail /dev/led");
		exit(-1);
	}

	// initialize FND
	if((fdFnd = open(DEVICE_FND, O_RDWR)) < 0)
	{
		perror("open fail /dev/fnd");
		exit(-1);
	}

	// initialize DOT
	if((fdDot = open(DEVICE_DOT, O_RDWR)) < 0)
	{
		perror("open fail /dev/dot");
		exit(-1);
	}

	// initialize Mem
	if((fdMem = open(DEVICE_MEM, O_RDWR|O_SYNC)) < 0)
	{
		perror("open fail /dev/mem");
		exit(-1);
	}

	pthread_create(&threadCredit, NULL, threadEndingCredit, NULL);

	// 시작 모션
	motionGetReady();
	
	// 게임 시작
	nGameStatus = RUNNING;

	pthread_create(&threadMap, NULL, threadRunningMap, NULL);
	pthread_create(&threadSpeed, NULL, threadRunningSpeed, NULL);
	pthread_create(&threadRefresh, NULL, threadRefreshDot, NULL);

	while(TRUE)
	{
		cLetter = getKeyInput(10);

		if(cLetter == KEY_LEFT)
		{
			moveLeft();
		}
		else if(cLetter == KEY_RIGHT)
		{
			moveRight();
		}
	}
}

// 키 입력을 받는다.
unsigned char getKeyInput(int tmo)
{   
	unsigned char b;

	if (tmo)
	{ 
		if (tmo < 0)
		{
			tmo = ~tmo * 1000;
		}
		else
		{
			tmo *= 1000000;
		}

		while (tmo > 0)
		{
			usleep(100000); //감도
			ioctl(fdKey, FIONREAD, &b);

			if (b)
			{
				return(b);
			}
			tmo -= 10000;
		}

		return(-1); /* timeout */
	}
	else
	{
		read(fdKey, &b, sizeof(b));
		return(b);
	}
}

// 게임이 종료되었을 때 처리
void endGame()
{
	BOOL bBlink = FALSE;
	int nScoreTemp;

	// crashed!
	motionCrashed();
	motionCrashed();
	motionCrashed();


	while(TRUE)
	{
		showFNDDisplayNumber(bBlink);
		bBlink = bBlink ^ TRUE;

		usleep(1000000);
	}
}

// 맵을 하단으로 스크롤한다.
void* threadRunningMap()
{
	while(nGameStatus != STOPPED)
	{
		nScore += 1;
		TranslateDot();
		showFNDDisplayNumber(FALSE);
		usleep(120000 - (nStage * 10000));

		if(nScore > nStage * 100)
		{
			nStage++;
		}
	}

	endGame();
}

// DOT 디바이스의 내용을 갱신한다.
void* threadRefreshDot()
{
	BOOL bBlink = FALSE;

	while(TRUE)
	{
		displayDot(bBlink);
		bBlink = bBlink ^ TRUE;

		usleep(20000);
	}
}

// 제작자 목록을 보여준다.
void* threadEndingCredit()
{
	BOOL bFirst = FALSE;

	while(TRUE)
	{
		endingCredit(bFirst);

		bFirst = bFirst ^ TRUE;

		usleep(800000);
	}
}

// LED 값을 출력한다.
void setLedValue(unsigned char cValue)
{
	// for invert led
	cValue = cValue ^ 0xff;

	write (fdLed, &cValue, sizeof(unsigned char));
}

// 맵이 내려오는 속도를 조절한다.
void* threadRunningSpeed()
{
	int nIndex = 1;

	while(nGameStatus != STOPPED)
	{
		setLedValue(nIndex);
		usleep(100000 - (nStage * 10000));

		if(nIndex > 255)
		{
			nIndex = 1;
		}
		else
		{
			nIndex *= 2;
		}
	}
}

// FND에 출력할 값을 변환한다.
char convertValueToChar(int nValue)
{
	unsigned char cLetter;

	switch (nValue)
	{
		case  0:    cLetter = FND_CHAR_0;       break;
		case  1:    cLetter = FND_CHAR_1;       break;
		case  2:    cLetter = FND_CHAR_2;       break;
		case  3:    cLetter = FND_CHAR_3;       break;
		case  4:    cLetter = FND_CHAR_4;       break;
		case  5:    cLetter = FND_CHAR_5;       break;
		case  6:    cLetter = FND_CHAR_6;       break;
		case  7:    cLetter = FND_CHAR_7;       break;
		case  8:    cLetter = FND_CHAR_8;       break;
		case  9:    cLetter = FND_CHAR_9;       break;
		case  10:   cLetter = FND_CHAR_A;       break;
		case  11:   cLetter = FND_CHAR_B;       break;
		case  12:   cLetter = FND_CHAR_C;       break;
		case  13:   cLetter = FND_CHAR_D;       break;
		case  14:   cLetter = FND_CHAR_E;       break;
		case  15:   cLetter = FND_CHAR_F;       break;
		default:    cLetter = FND_CHAR_NONE;    break;
	}

	return cLetter;
}

// FND에 내용을 출력한다.
void showFNDDisplayNumber(BOOL bOff)
{
	unsigned char szBuffer[MAXFND + 1];
	unsigned char cLetter;
	int nCount;
	int nValue;
	int nTemp;

	memset(szBuffer, 0, sizeof(szBuffer));

	nTemp = nScore;

	for(nCount = MAXFND - 1 ; nCount > -1 ; nCount--)
	{
		if(nTemp != 0)
		{
			nValue = nTemp % 10;
			nTemp = (int) nTemp / 10;
		}
		else
		{
			nValue = 0;
		}

		if(bOff)
		{
			cLetter = FND_CHAR_NONE;
		}
		else
		{
			cLetter = convertValueToChar(nValue);
		}

		szBuffer[nCount] = cLetter;
	}

	// 레벨 표기
	szBuffer[0] = FND_CHAR_L;
	szBuffer[1] = convertValueToChar(nStage);

	write(fdFnd, szBuffer, MAXFND);
}

// 자동차를 왼쪽으로 이동한다.
void moveLeft()
{
	printf("CAR MOVES LEFT\n");
	nCarPosition--;

	if(nCarPosition < CAR_LEFT)
	{
		nCarPosition = CAR_LEFT;
	}
}

// 자동차를 오른쪽으로 이동한다.
void moveRight()
{
	printf("CAR MOVES RIGHT\n");
	nCarPosition++;

	if(nCarPosition > CAR_RIGHT)
	{
		nCarPosition = CAR_RIGHT;
	}
}

// 기본 배열을 맵으로 변환한다.
void displayDot(BOOL bBlink)
{
	BOOL bCrashed;
	//맵그려주고

	//차의 위치에 대해서 표시 or 연산
	if(nGameStatus == RUNNING)
	{
		if(bBlink)
		{
			arrOutputDotCol[nCarPosition] = arrOutputDotCol[nCarPosition] & 0xfd;
		}
		else
		{
			bCrashed = arrOutputDotCol[nCarPosition] & 0x02;
			arrOutputDotCol[nCarPosition] = arrOutputDotCol[nCarPosition] | 0x02;
		}
	}

	//써주기
	write(fdDot, arrOutputDotCol, MAXDOT);

	if(bCrashed)
	{
		nGameStatus = STOPPED;
	}
}

// DOT 디바이스에 직접 쓰는 함수
void displayDotOnly()
{
	write(fdDot, arrOutputDotCol, MAXDOT);
}

// 맵 배열을 5자리 DOT용 배열로 변환
void TranslateDot()
{
	int nValue = 0;
	int i, j;

	if (nMapCount >= MAXROW * MAXCOL)
	{
		srand(time(NULL));
		nMapSelect = rand() % 5;
		nMapCount = 0;
	}

	// map한칸씩 내리기
	for (i = 0 ; i < MAXROW - 1 ; i++)
	{
		for (j = 0 ; j < MAXCOL ; j++)
		{
			arrInputDotCol[i][j] = arrInputDotCol[i + 1][j];
		}
	}

	// top row에 map추가
	for (j = 0 ; j < MAXCOL ; j++)
	{
		arrInputDotCol[MAXROW - 1][j] = arrRacingMap[nMapSelect][nMapCount][j];
	}

	nMapCount++;
	
	for (j = 0 ; j < MAXCOL ; j++ ) 
	{
		for (i = 0 ; i < MAXROW ; i++) 
		{
			nValue += (arrBinary[i] * arrInputDotCol[i][j]);
		}		

		arrOutputDotCol[j] = 0x7F & nValue;
		nValue = 0;
	}
}

// 시작전 화면 모션
void motionGetReady()
{
    arrOutputDotCol[0] = 0x49;
	arrOutputDotCol[1] = 0x49;
	arrOutputDotCol[2] = 0x49;
	arrOutputDotCol[3] = 0x49;
	arrOutputDotCol[4] = 0x7F;
    displayDotOnly();
    sleep(1.5);

    arrOutputDotCol[0] = 0x4F;
	arrOutputDotCol[1] = 0x49;
	arrOutputDotCol[2] = 0x49;
	arrOutputDotCol[3] = 0x49;
	arrOutputDotCol[4] = 0x79;
    displayDotOnly();
    sleep(1.5);

    arrOutputDotCol[0] = 0x00;
	arrOutputDotCol[1] = 0x00;
	arrOutputDotCol[2] = 0x7F;
	arrOutputDotCol[3] = 0x00;
	arrOutputDotCol[4] = 0x00;
	displayDotOnly();
    sleep(1.5);
}

// 자동차 충돌시 모션
void motionCrashed()
{
    arrOutputDotCol[0] = 0x00;
	arrOutputDotCol[1] = 0x00;
	arrOutputDotCol[2] = 0x08;
	arrOutputDotCol[3] = 0x00;
	arrOutputDotCol[4] = 0x00;
	displayDotOnly();
    usleep(100000);

    arrOutputDotCol[0] = 0x00;
	arrOutputDotCol[1] = 0x08;
	arrOutputDotCol[2] = 0x14;
	arrOutputDotCol[3] = 0x08;
	arrOutputDotCol[4] = 0x00;
	displayDotOnly();
    usleep(100000);

    arrOutputDotCol[0] = 0x00;
	arrOutputDotCol[1] = 0x1c;
	arrOutputDotCol[2] = 0x14;
	arrOutputDotCol[3] = 0x1c;
	arrOutputDotCol[4] = 0x00;
	displayDotOnly();
    usleep(100000);

    arrOutputDotCol[0] = 0x08;
	arrOutputDotCol[1] = 0x14;
	arrOutputDotCol[2] = 0x22;
	arrOutputDotCol[3] = 0x14;
	arrOutputDotCol[4] = 0x08;
	displayDotOnly();
    usleep(300000);
}

void initTextLcd()
{
	pTextlcd = mmap(NULL, 4, PROT_WRITE, MAP_SHARED, fdMem, ADDRLCD);
	pTextlcd_cmd = mmap(NULL, 4, PROT_WRITE, MAP_SHARED, fdMem, ADDRLCD_CMD);

	setCommand(CMD_INITIALIZE);
	setCommand(CMD_INITIALIZE);
	setCommand(CMD_INITIALIZE);		// Data Length:8, Lines:2, Font:5x10
	setCommand(CMD_DISPLAY_ON);		// Display On
	setCommand(CMD_CURSOR_HOME);	// Return home
	setCommand(CMD_DISPLAY_CLS);	// Clear display
	usleep(2000);
}

// CLCD에 명령 수행
void setCommand(unsigned short usCommand)
{
	usCommand &= 0x00FF;
	*pTextlcd_cmd = usCommand|0x0000;
	*pTextlcd_cmd = usCommand|0x0400;
	*pTextlcd_cmd = usCommand|0x0000;
	usleep(50);
}

// 문자열 표시
void writeByte(char cInput)
{
	unsigned short usData = cInput & 0x00ff;

	*pTextlcd = usData | 0x100;
	*pTextlcd = usData | 0x500;
	*pTextlcd = usData | 0x100;
	usleep(50);
}

// CLCD에 제작자 이름 출력
void endingCredit(int nOrder)
{
	char *szPersons[] = {
							"2201113 Park, WR",
							"2501220 Park, DS",
							"2501230 Woo, YH",
							"2501324 Min, CH"
						};

	int nIndex, nPersonCount, nLength, nStartCount;

	// initialize Text LCD
	initTextLcd();

	nStartCount = nOrder * 2;

	for(nPersonCount = nStartCount ; nPersonCount < nStartCount + 2 ; nPersonCount++)
	{
		nLength = strlen(szPersons[nPersonCount]);

		for(nIndex = 0; nIndex < nLength ; nIndex++)
		{
			writeByte(szPersons[nPersonCount][nIndex]);
			usleep(5000);
		}

		setCommand(CMD_CURSOR_NL);
	}

	munmap(pTextlcd, 4);
	munmap(pTextlcd_cmd, 4);
}
