////////////////////////////////////////////////////////////
////
////            EMBEDDED SYSTEM PROGRAMMING
////
////                                      COMPUTER SCIENCE
////
////                                      2201113 박우람
////                                      2501220 박대선
////                                      2501230 우연화
////                                      2501324 민충희
////
//////////////////////////////////////////////////////////////
#define BOOL            int
#define TRUE            1
#define FALSE           0

// FND 캐릭터 정의
#define FND_CHAR_NONE   0x00
#define FND_CHAR_0      0x3f
#define FND_CHAR_1      0x06
#define FND_CHAR_2      0x5b
#define FND_CHAR_3      0x4f
#define FND_CHAR_4      0x66
#define FND_CHAR_5      0x6d
#define FND_CHAR_6      0x7d
#define FND_CHAR_7      0x07
#define FND_CHAR_8      0x7f
#define FND_CHAR_9      0x67
#define FND_CHAR_A      0x5f
#define FND_CHAR_B      0x7c
#define FND_CHAR_C      0x39
#define FND_CHAR_D      0x5e
#define FND_CHAR_E      0x79
#define FND_CHAR_F      0x71
#define FND_CHAR_L      0x38
#define FND_CHAR_O      0x5c
#define FND_CHAR_R      0x50
#define FND_CHAR_S      0x6d
#define FND_CHAR_U      0x3e
#define FND_SPCL_N      0x40

// 키 매트릭스 정의
#define KEY_LEFT		1
#define KEY_NUM2		2
#define KEY_RIGHT		3
#define KEY_NUM4        4
#define KEY_NUM5        5
#define KEY_NUM6        6
#define KEY_NUM7        7
#define KEY_NUM8        8
#define KEY_NUM9        9
#define KEY_NUM10       10
#define KEY_NUM11       11
#define KEY_NUM12       12
#define KEY_NUM13       13
#define KEY_NUM14       14
#define KEY_NUM15       15
#define KEY_NUM16       16

// CLCD 명령 정의
#define CMD_CURSOR_ON 0x0f
#define CMD_CURSOR_OFF 0x0c 
#define CMD_CURSOR_NL 0xc0 
#define CMD_CURSOR_HOME 0x02
#define CMD_INITIALIZE 0x38
#define CMD_DISPLAY_ON 0x0c
#define CMD_DISPLAY_CLS 0x01
#define CMD_CURSOR_UP 0x90
#define CMD_CURSOR_LEFT 0x10
#define CMD_CURSOR_RIGHT 0x14

// 게임중 사용되는 상태값 정의
enum CAR_POSITION
{
	CAR_LEFT,
	CAR_CENTER_LEFT,
	CAR_CENTER,
	CAR_CENTER_RIGHT,
	CAR_RIGHT
};

enum GAME_STATUS
{
	READY,
	RUNNING,
	STOPPED
};

#define MAXFND			8
#define MAXDOT			5
#define	MAXROW			7
#define MAXCOL			5

// 디바이스 목록
#define DEVICE_KEY  "/dev/key"
#define DEVICE_LED  "/dev/led"
#define DEVICE_FND  "/dev/fnd"
#define DEVICE_DOT  "/dev/dot"
#define DEVICE_MEM	"/dev/mem"

#define ADDRLCD 0x12380000
#define ADDRLCD_CMD 0x12300000

// 파일 디스크립터
static int  fdKey = (-1);
static int  fdLed = (-1);
static int  fdFnd = (-1);
static int  fdDot = (-1);
static int	fdMem = (-1);

// 게임에 사용되는 전역변수
static int  nStage = 1;
static int  nScore = 0;
static int	nMapCount = 9999;
static int	nMapSelect = 0;
static enum GAME_STATUS nGameStatus = READY;
static int  nCarPosition = CAR_CENTER;

unsigned int arrBinary[7] = {1, 2, 4, 8, 16, 32, 64};
unsigned char arrOutputDotCol[5];
unsigned char arrInputDotCol[7][5];

unsigned short *pTextlcd;
unsigned short *pTextlcd_cmd;

// 함수 프로토타입
void* threadRunningMap();
void* threadRunningSpeed();
void* threadRefreshDot();
void* threadEndingCredit();
unsigned char getKeyInput(int tmo);
void setLedValue(unsigned char cValue);
char convertValueToChar(int nValue);
void showFNDDisplayNumber(BOOL bOff);
void moveLeft();
void moveRight();
void displayDot(BOOL bBlink);
void TranslateDot();
void motionGetReady();
void motionCrashed();
void displayDotOnly();
void endGame();
void initTextLcd();
void setCommand(unsigned short usCommand);
void writeByte(char cInput);
void endingCredit(int nOrder);
